# FeynmanDB
#
# Copyright (c) 2024 Sameer Rahmani <lxsameer@gnu.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
{ deps, writeShellApplication, cmake, ninja, clang_17, ...}:
let
  compile = writeShellApplication {
    name = "compile";
    runtimeInputs = deps;

    text = ''
      mkdir -p ./build
      cd build
      ${cmake}/bin/cmake -GNinja .. -DCMAKE_CXX_FLAGS="-v" "$@"
      ${ninja}/bin/ninja -j32 -v
    '';
  };

  run = writeShellApplication {
    name = "run";
    text = ''
      "$(pwd)/build/feynman/feynman" "$@"
    '';
  };

  build = writeShellApplication {
    name = "build";
    runtimeInputs = [ compile ] ++ deps;

    text = ''
      rm -rf ./build
      ${compile}/bin/compile "$@"
    '';
  };

in {
  inherit compile run build;
}
